xref: /freebsd/libexec/rc/rc.subr (revision b64c5a0ace59af62eff52bfe110a521dc73c937b)
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2#
3# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
4# All rights reserved.
5#
6# This code is derived from software contributed to The NetBSD Foundation
7# by Luke Mewburn.
8#
9# Redistribution and use in source and binary forms, with or without
10# modification, are permitted provided that the following conditions
11# are met:
12# 1. Redistributions of source code must retain the above copyright
13#    notice, this list of conditions and the following disclaimer.
14# 2. Redistributions in binary form must reproduce the above copyright
15#    notice, this list of conditions and the following disclaimer in the
16#    documentation and/or other materials provided with the distribution.
17#
18# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
19# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
20# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
21# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
22# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
23# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
24# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
25# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
26# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
27# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
28# POSSIBILITY OF SUCH DAMAGE.
29#
30# rc.subr
31#	functions used by various rc scripts
32#
33
34: ${RC_PID:=$$}; export RC_PID
35
36#
37#	Operating System dependent/independent variables
38#
39
40if [ -n "${_rc_subr_loaded}" ]; then
41	return
42fi
43
44_rc_subr_loaded="YES"
45
46SYSCTL="/sbin/sysctl"
47SYSCTL_N="${SYSCTL} -n"
48SYSCTL_W="${SYSCTL}"
49PROTECT="/usr/bin/protect"
50ID="/usr/bin/id"
51IDCMD="if [ -x $ID ]; then $ID -un; fi"
52PS="/bin/ps -ww"
53SERVICE=/usr/sbin/service
54JAIL_CMD=/usr/sbin/jail
55_svcj_generic_params="path=/ mount.nodevfs host=inherit"
56JID=0
57CPUSET="/bin/cpuset"
58
59# rc_service provides the path to the service script that we are executing.
60# This is not being set here in an execution context, necessarily, so it's
61# really just a reasonable guess, and it will get overwritten later if
62# we are executing from some other means than direct execution by service(8)
63# or manual invocation of the service script.  The prime example of this is
64# during system startup, all rc scripts will be invoked via /etc/rc, so
65# run_rc_script will overwrite rc_service with the file being sourced.
66rc_service="$0"
67
68#
69#	functions
70#	---------
71
72# is_verified file
73#	if VERIEXEC is active check that $file is verified
74#
75VERIEXEC="/sbin/veriexec"
76if test -x $VERIEXEC && $VERIEXEC -i active > /dev/null 2>&1; then
77	is_verified() { $VERIEXEC -x $1; }
78else
79	is_verified() { return 0; }
80fi
81
82# indicate that we have vdot
83_VDOT_SH=:
84
85# current state of O_VERIFY
86o_verify()
87{
88	case $(echo $(set -o)) in
89	*verify" "off*) echo off;;
90	*verify" "on*) echo on;;
91	esac
92}
93
94##
95# o_verify_set want [save]
96#
97# record current state of verify in $save
98# and set it to $want if different
99#
100o_verify_set() {
101	local x=$(o_verify)
102
103	[ -z "$x" ] && return 0
104	[ -z "$2" ] || eval $2=$x
105	[ "$x" = "$1" ] && return 0
106	case "$1" in
107	on)
108		set -o verify
109		;;
110	off)
111		set +o verify
112		;;
113	esac
114}
115
116# for unverified files
117dotted=
118dot()
119{
120	local f verify
121
122	o_verify_set off verify
123	for f in "$@"; do
124		if [ -f $f -a -s $f ]; then
125			dotted="$dotted $f"
126			. $f
127		fi
128	done
129	o_verify_set $verify
130}
131
132# try for verified, fallback to safe
133sdot()
134{
135	local f
136
137	for f in "$@"; do
138		[ -f $f -a -s $f ] || continue
139		vdot $f || safe_dot $f
140	done
141}
142
143# convenience function - skip if not verified
144vdot()
145{
146	local f rc=0 verify
147
148	o_verify_set on verify
149	for f in "$@"; do
150		[ -f $f -a -s $f ] || continue
151		if is_verified $f 2> /dev/null; then
152			dotted="$dotted $f"
153			. $f
154		else
155			rc=80	# EAUTH
156		fi
157	done
158	o_verify_set $verify
159	return $rc
160}
161
162# Exists [test] file ...
163# report the first "file" that passes "test" (default -s).
164Exists()
165{
166	local f _t=-s
167
168	while :; do
169		: 1=$1
170		case "$1" in
171		-?)
172			_t=$1
173			shift
174			;;
175		*)
176			break
177			;;
178		esac
179	done
180
181	for f in "$@"; do
182		[ $_t $f ] || continue
183		echo $f
184		return 0
185	done
186	return 1
187}
188
189# do we have $1 (could be a function)
190have()
191{
192       type "$1" > /dev/null 2>&1
193}
194
195# provide consistent means of logging progress
196rc_log()
197{
198	date "+@ %s [%Y-%m-%d %H:%M:%S %Z] $*"
199}
200
201# only rc_log if tracing enabled
202# and $level >= $RC_LEVEL
203rc_trace()
204{
205	local level=$1; shift
206	local cf=/etc/rc.conf.d/rc_trace
207
208	if [ -z "$RC_LEVEL" ]; then
209		[ -f $cf ] || return
210		if [ -s $cf ]; then
211			# don't try to set RC_LEVEL without sed
212			if [ -n "$SED" ]; then
213				RC_LEVEL=$($SED -n '/^RC_LEVEL=/ { s/.*=//p;q; }' $cf)
214				RC_LEVEL=${RC_LEVEL:-0}
215			fi
216		else
217			RC_LEVEL=0
218		fi
219	fi
220	[ ${RC_LEVEL:-0} -ge ${level:-0} ] || return
221	rc_log "$@"
222}
223
224# list_vars pattern
225#	List variables matching glob pattern.
226#
227list_vars()
228{
229	# Localize 'set' option below.
230	local -
231	local IFS=$'\n' line varname
232
233	# Disable path expansion in unquoted 'for' parameters below.
234	set -o noglob
235
236	for line in $(set); do
237		varname="${line%%=*}"
238
239		case "$varname" in
240		"$line"|*[!a-zA-Z0-9_]*)
241			continue
242			;;
243		$1)
244			echo $varname
245			;;
246		esac
247	done
248}
249
250# set_rcvar [var] [defval] [desc]
251#
252#	Echo or define a rc.conf(5) variable name.  Global variable
253#	$rcvars is used.
254#
255#	If no argument is specified, echo "${name}_enable".
256#
257#	If only a var is specified, echo "${var}_enable".
258#
259#	If var and defval are specified, the ${var} is defined as
260#	rc.conf(5) variable and the default value is ${defvar}.  An
261#	optional argument $desc can also be specified to add a
262#	description for that.
263#
264set_rcvar()
265{
266	local _var
267
268	case $# in
269	0)	echo ${name}_enable ;;
270	1)	echo ${1}_enable ;;
271	*)
272		debug "set_rcvar: \$$1=$2 is added" \
273		    " as a rc.conf(5) variable."
274		_var=$1
275		rcvars="${rcvars# } $_var"
276		eval ${_var}_defval=\"$2\"
277		shift 2
278		eval ${_var}_desc=\"$*\"
279	;;
280	esac
281}
282
283# set_rcvar_obsolete oldvar [newvar] [msg]
284#	Define obsolete variable.
285#	Global variable $rcvars_obsolete is used.
286#
287set_rcvar_obsolete()
288{
289	local _var
290	_var=$1
291	debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
292
293	rcvars_obsolete="${rcvars_obsolete# } $1"
294	eval ${1}_newvar=\"$2\"
295	shift 2
296	eval ${_var}_obsolete_msg=\"$*\"
297}
298
299#
300# force_depend script [rcvar]
301#	Force a service to start. Intended for use by services
302#	to resolve dependency issues.
303#	$1 - filename of script, in /etc/rc.d, to run
304#	$2 - name of the script's rcvar (minus the _enable)
305#
306force_depend()
307{
308	local _depend _dep_rcvar
309
310	_depend="$1"
311	_dep_rcvar="${2:-$1}_enable"
312
313	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
314	    checkyesno $_dep_rcvar && return 0
315
316	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
317
318	info "${name} depends on ${_depend}, which will be forced to start."
319	if ! /etc/rc.d/${_depend} forcestart; then
320		warn "Unable to force ${_depend}. It may already be running."
321		return 1
322	fi
323}
324
325#
326# checkyesno var
327#	Test $1 variable, and warn if not set to YES or NO.
328#	Return 0 if it's "yes" (et al), nonzero otherwise.
329#
330checkyesno()
331{
332	eval _value=\$${1}
333	debug "checkyesno: $1 is set to $_value."
334	case $_value in
335
336		#	"yes", "true", "on", or "1"
337	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
338		return 0
339		;;
340
341		#	"no", "false", "off", or "0"
342	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
343		return 1
344		;;
345	*)
346		warn "\$${1} is not set properly - see rc.conf(5)."
347		return 1
348		;;
349	esac
350}
351
352#
353# reverse_list list
354#	print the list in reverse order
355#
356reverse_list()
357{
358	_revlist=
359	for _revfile; do
360		_revlist="$_revfile $_revlist"
361	done
362	echo $_revlist
363}
364
365# stop_boot always
366#	If booting directly to multiuser or $always is enabled,
367#	send SIGTERM to the parent (/etc/rc) to abort the boot.
368#	Otherwise just exit.
369#
370stop_boot()
371{
372	local always
373
374	case $1 in
375		#	"yes", "true", "on", or "1"
376	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
377		always=true
378		;;
379	*)
380		always=false
381		;;
382	esac
383	if [ "$autoboot" = yes -o "$always" = true ]; then
384		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
385		kill -TERM ${RC_PID}
386	fi
387	exit 1
388}
389
390#
391# mount_critical_filesystems type
392#	Go through the list of critical filesystems as provided in
393#	the rc.conf(5) variable $critical_filesystems_${type}, checking
394#	each one to see if it is mounted, and if it is not, mounting it.
395#
396mount_critical_filesystems()
397{
398	eval _fslist=\$critical_filesystems_${1}
399	for _fs in $_fslist; do
400		mount | (
401			_ismounted=false
402			while read what _on on _type type; do
403				if [ $on = $_fs ]; then
404					_ismounted=true
405				fi
406			done
407			if $_ismounted; then
408				:
409			else
410				mount $_fs >/dev/null 2>&1
411			fi
412		)
413	done
414}
415
416#
417# check_pidfile pidfile procname [interpreter]
418#	Parses the first line of pidfile for a PID, and ensures
419#	that the process is running and matches procname.
420#	Prints the matching PID upon success, nothing otherwise.
421#	interpreter is optional; see _find_processes() for details.
422#
423check_pidfile()
424{
425	_pidfile=$1
426	_procname=$2
427	_interpreter=$3
428	if [ -z "$_pidfile" -o -z "$_procname" ]; then
429		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
430	fi
431	if [ ! -f $_pidfile ]; then
432		debug "pid file ($_pidfile): not readable."
433		return
434	fi
435	read _pid _junk < $_pidfile
436	if [ -z "$_pid" ]; then
437		debug "pid file ($_pidfile): no pid in file."
438		return
439	fi
440	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
441}
442
443#
444# check_process procname [interpreter]
445#	Ensures that a process (or processes) named procname is running.
446#	Prints a list of matching PIDs.
447#	interpreter is optional; see _find_processes() for details.
448#
449check_process()
450{
451	_procname=$1
452	_interpreter=$2
453	if [ -z "$_procname" ]; then
454		err 3 'USAGE: check_process procname [interpreter]'
455	fi
456	_find_processes $_procname ${_interpreter:-.} '-ax'
457}
458
459#
460# _find_processes procname interpreter psargs
461#	Search for procname in the output of ps generated by psargs.
462#	Prints the PIDs of any matching processes, space separated.
463#
464#	If interpreter == ".", check the following variations of procname
465#	against the first word of each command:
466#		procname
467#		`basename procname`
468#		`basename procname` + ":"
469#		"(" + `basename procname` + ")"
470#		"[" + `basename procname` + "]"
471#
472#	If interpreter != ".", read the first line of procname, remove the
473#	leading #!, normalise whitespace, append procname, and attempt to
474#	match that against each command, either as is, or with extra words
475#	at the end.  As an alternative, to deal with interpreted daemons
476#	using perl, the basename of the interpreter plus a colon is also
477#	tried as the prefix to procname.
478#
479_find_processes()
480{
481	if [ $# -ne 3 ]; then
482		err 3 'USAGE: _find_processes procname interpreter psargs'
483	fi
484	_procname=$1
485	_interpreter=$2
486	_psargs=$3
487
488	_pref=
489	if [ $_interpreter != "." ]; then	# an interpreted script
490		_script="${_chroot}${_chroot:+/}$_procname"
491		if [ -r "$_script" ]; then
492			read _interp < $_script	# read interpreter name
493			case "$_interp" in
494			\#!*)
495				_interp=${_interp#\#!}	# strip #!
496				set -- $_interp
497				case $1 in
498				*/bin/env)
499					shift	# drop env to get real name
500					;;
501				esac
502				if [ $_interpreter != $1 ]; then
503					warn "\$command_interpreter $_interpreter != $1"
504				fi
505				;;
506			*)
507				warn "no shebang line in $_script"
508				set -- $_interpreter
509				;;
510			esac
511		else
512			warn "cannot read shebang line from $_script"
513			set -- $_interpreter
514		fi
515		_interp="$* $_procname"		# cleanup spaces, add _procname
516		_interpbn=${1##*/}
517		_fp_args='_argv'
518		_fp_match='case "$_argv" in
519		    ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
520	else					# a normal daemon
521		_procnamebn=${_procname##*/}
522		_fp_args='_arg0 _argv'
523		_fp_match='case "$_arg0" in
524		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
525	fi
526
527	if checkyesno ${name}_svcj && [ "${_rc_svcj}" != jailing ]; then
528		JID=$(/usr/sbin/jls -j svcj-${name} jid 2>/dev/null)
529
530		case ${JID} in
531		''|*[!0-9]*)
532			# svcj-jail doesn't exist, fallback to host-check
533			JID=0
534			;;
535		esac
536	fi
537	_proccheck="\
538		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
539		while read _npid _jid '"$_fp_args"'; do
540			'"$_fp_match"'
541				if [ "$JID" -eq "$_jid" ];
542				then echo -n "$_pref$_npid";
543				_pref=" ";
544				fi
545				;;
546			esac
547		done'
548
549#	debug "in _find_processes: proccheck is ($_proccheck)."
550	eval $_proccheck
551}
552
553# sort_lite [-b] [-n] [-k POS] [-t SEP]
554#	A lite version of sort(1) (supporting a few options) that can be used
555#	before the real sort(1) is available (e.g., in scripts that run prior
556#	to mountcritremote). Requires only shell built-in functionality.
557#
558sort_lite()
559{
560	local funcname=sort_lite
561	local sort_sep="$IFS" sort_ignore_leading_space=
562	local sort_field=0 sort_strict_fields= sort_numeric=
563	local nitems=0 skip_leading=0 trim=
564
565	local OPTIND flag
566	while getopts bnk:t: flag; do
567		case "$flag" in
568		b) sort_ignore_leading_space=1 ;;
569		n) sort_numeric=1 sort_ignore_leading_space=1 ;;
570		k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
571			# NB: Unlike sort(1) only one POS allowed
572		t) sort_sep="$OPTARG"
573		   if [ ${#sort_sep} -gt 1 ]; then
574		   	echo "$funcname: multi-character tab \`$sort_sep'" >&2
575		   	return 1
576		   fi
577		   sort_strict_fields=1
578		   ;;
579		\?) return 1 ;;
580		esac
581	done
582	shift $(( $OPTIND - 1 ))
583
584	# Create transformation pattern to trim leading text if desired
585	case "$sort_field" in
586	""|[!0-9]*|*[!0-9.]*)
587		echo "$funcname: invalid sort field \`$sort_field'" >&2
588		return 1
589		;;
590	*.*)
591		skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
592		while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
593			trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
594		done
595	esac
596
597	# Copy input to series of local numbered variables
598	# NB: IFS of NULL preserves leading whitespace
599	local LINE
600	while IFS= read -r LINE || [ "$LINE" ]; do
601		nitems=$(( $nitems + 1 ))
602		local src_$nitems="$LINE"
603	done
604
605	#
606	# Sort numbered locals using insertion sort
607	#
608	local curitem curitem_orig curitem_mod curitem_haskey
609	local dest dest_orig dest_mod dest_haskey
610	local d gt n
611	local i=1
612	while [ $i -le $nitems ]; do
613		curitem_haskey=1 # Assume sort field (-k POS) exists
614		eval curitem=\"\$src_$i\"
615		curitem_mod="$curitem" # for modified comparison
616		curitem_orig="$curitem" # for original comparison
617
618		# Trim leading whitespace if desired
619		if [ "$sort_ignore_leading_space" ]; then
620			while case "$curitem_orig" in
621				[$IFS]*) : ;; *) false; esac
622			do
623				curitem_orig="${curitem_orig#?}"
624			done
625			curitem_mod="$curitem_orig"
626		fi
627
628		# Shift modified comparison value if sort field (-k POS) is > 1
629		n=$sort_field
630		while [ $n -gt 1 ]; do
631			case "$curitem_mod" in
632			*[$sort_sep]*)
633				# Cut text up-to (and incl.) first separator
634				curitem_mod="${curitem_mod#*[$sort_sep]}"
635
636				# Skip NULLs unless strict field splitting
637				[ "$sort_strict_fields" ] ||
638					[ "${curitem_mod%%[$sort_sep]*}" ] ||
639					[ $n -eq 2 ] ||
640					continue
641				;;
642			*)
643				# Asked for a field that doesn't exist
644				curitem_haskey= break
645			esac
646			n=$(( $n - 1 ))
647		done
648
649		# Trim trailing words if sort field >= 1
650		[ $sort_field -ge 1 -a "$sort_numeric" ] &&
651			curitem_mod="${curitem_mod%%[$sort_sep]*}"
652
653		# Apply optional trim (-k POS.TRIM) to cut leading characters
654		curitem_mod="${curitem_mod#$trim}"
655
656		# Determine the type of modified comparison to use initially
657		# NB: Prefer numerical if requested but fallback to standard
658		case "$curitem_mod" in
659		""|[!0-9]*) # NULL or begins with non-number
660			gt=">"
661			[ "$sort_numeric" ] && curitem_mod=0
662			;;
663		*)
664			if [ "$sort_numeric" ]; then
665				gt="-gt"
666				curitem_mod="${curitem_mod%%[!0-9]*}"
667					# NB: trailing non-digits removed
668					# otherwise numeric comparison fails
669			else
670				gt=">"
671			fi
672		esac
673
674		# If first time through, short-circuit below position-search
675		if [ $i -le 1 ]; then
676			d=0
677		else
678			d=1
679		fi
680
681		#
682		# Find appropriate element position
683		#
684		while [ $d -gt 0 ]
685		do
686			dest_haskey=$curitem_haskey
687			eval dest=\"\$dest_$d\"
688			dest_mod="$dest" # for modified comparison
689			dest_orig="$dest" # for original comparison
690
691			# Trim leading whitespace if desired
692			if [ "$sort_ignore_leading_space" ]; then
693				while case "$dest_orig" in
694					[$IFS]*) : ;; *) false; esac
695				do
696					dest_orig="${dest_orig#?}"
697				done
698				dest_mod="$dest_orig"
699			fi
700
701			# Shift modified value if sort field (-k POS) is > 1
702			n=$sort_field
703			while [ $n -gt 1 ]; do
704				case "$dest_mod" in
705				*[$sort_sep]*)
706					# Cut text up-to (and incl.) 1st sep
707					dest_mod="${dest_mod#*[$sort_sep]}"
708
709					# Skip NULLs unless strict fields
710					[ "$sort_strict_fields" ] ||
711					    [ "${dest_mod%%[$sort_sep]*}" ] ||
712					    [ $n -eq 2 ] ||
713					    continue
714					;;
715				*)
716					# Asked for a field that doesn't exist
717					dest_haskey= break
718				esac
719				n=$(( $n - 1 ))
720			done
721
722			# Trim trailing words if sort field >= 1
723			[ $sort_field -ge 1 -a "$sort_numeric" ] &&
724				dest_mod="${dest_mod%%[$sort_sep]*}"
725
726			# Apply optional trim (-k POS.TRIM), cut leading chars
727			dest_mod="${dest_mod#$trim}"
728
729			# Determine type of modified comparison to use
730			# NB: Prefer numerical if requested, fallback to std
731			case "$dest_mod" in
732			""|[!0-9]*) # NULL or begins with non-number
733				gt=">"
734				[ "$sort_numeric" ] && dest_mod=0
735				;;
736			*)
737				if [ "$sort_numeric" ]; then
738					gt="-gt"
739					dest_mod="${dest_mod%%[!0-9]*}"
740						# NB: kill trailing non-digits
741						# for numeric comparison safety
742				else
743					gt=">"
744				fi
745			esac
746
747			# Break if we've found the proper element position
748			if [ "$curitem_haskey" -a "$dest_haskey" ]; then
749				if [ "$dest_mod" = "$curitem_mod" ]; then
750					[ "$dest_orig" ">" "$curitem_orig" ] &&
751						break
752				elif [ "$dest_mod" $gt "$curitem_mod" ] \
753					2> /dev/null
754				then
755					break
756				fi
757			else
758				[ "$dest_orig" ">" "$curitem_orig" ] && break
759			fi
760
761			# Break if we've hit the end
762			[ $d -ge $i ] && break
763
764			d=$(( $d + 1 ))
765		done
766
767		# Shift remaining positions forward, making room for new item
768		n=$i
769		while [ $n -ge $d ]; do
770			# Shift destination item forward one placement
771			eval dest_$(( $n + 1 ))=\"\$dest_$n\"
772			n=$(( $n - 1 ))
773		done
774
775		# Place the element
776		if [ $i -eq 1 ]; then
777			local dest_1="$curitem"
778		else
779			local dest_$d="$curitem"
780		fi
781
782		i=$(( $i + 1 ))
783	done
784
785	# Print sorted results
786	d=1
787	while [ $d -le $nitems ]; do
788		eval echo \"\$dest_$d\"
789		d=$(( $d + 1 ))
790	done
791}
792
793#
794# wait_for_pids pid [pid ...]
795#	spins until none of the pids exist
796#
797wait_for_pids()
798{
799	local _list _prefix _nlist _j
800
801	_list="$@"
802	if [ -z "$_list" ]; then
803		return
804	fi
805	_prefix=
806	while true; do
807		_nlist="";
808		for _j in $_list; do
809			if kill -0 $_j 2>/dev/null; then
810				_nlist="${_nlist}${_nlist:+ }$_j"
811				[ -n "$_prefix" ] && sleep 1
812			fi
813		done
814		if [ -z "$_nlist" ]; then
815			break
816		fi
817		_list=$_nlist
818		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
819		_prefix=", "
820		pwait $_list 2>/dev/null
821	done
822	if [ -n "$_prefix" ]; then
823		echo "."
824	fi
825}
826
827#
828# get_pidfile_from_conf string file
829#
830#	Takes a string to search for in the specified file.
831#	Ignores lines with traditional comment characters.
832#
833# Example:
834#
835# if get_pidfile_from_conf string file; then
836#	pidfile="$_pidfile_from_conf"
837# else
838#	pidfile='appropriate default'
839# fi
840#
841get_pidfile_from_conf()
842{
843	if [ -z "$1" -o -z "$2" ]; then
844		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
845	fi
846
847	local string file line
848
849	string="$1" ; file="$2"
850
851	if [ ! -s "$file" ]; then
852		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
853	fi
854
855	while read line; do
856		case "$line" in
857		*[#\;]*${string}*)	continue ;;
858		*${string}*)		break ;;
859		esac
860	done < $file
861
862	if [ -n "$line" ]; then
863		line=${line#*/}
864		_pidfile_from_conf="/${line%%[\"\;]*}"
865	else
866		return 1
867	fi
868}
869
870#
871# check_startmsgs
872#	If rc_quiet is set (usually as a result of using faststart at
873#	boot time) check if rc_startmsgs is enabled.
874#
875check_startmsgs()
876{
877	if [ -n "$rc_quiet" ]; then
878		checkyesno rc_startmsgs
879	else
880		return 0
881	fi
882}
883
884#
885# startmsg
886#	Preferred method to use when displaying start messages in lieu of echo.
887#
888startmsg()
889{
890	check_startmsgs && echo "$@"
891}
892
893#
894# run_rc_command argument
895#	Search for argument in the list of supported commands, which is:
896#		"start stop restart rcvar status poll ${extra_commands}"
897#	If there's a match, run ${argument}_cmd or the default method
898#	(see below).
899#
900#	If argument has a given prefix, then change the operation as follows:
901#		Prefix	Operation
902#		------	---------
903#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
904#		force	Set ${rcvar} to YES, and set rc_force=yes
905#		one	Set ${rcvar} to YES
906#		quiet	Don't output some diagnostics, and set rc_quiet=yes
907#
908#	The following globals are used:
909#
910#	Name		Needed	Purpose
911#	----		------	-------
912#	name		y	Name of script.
913#
914#	command		n	Full path to command.
915#				Not needed if ${rc_arg}_cmd is set for
916#				each keyword.
917#
918#	command_args	n	Optional args/shell directives for command.
919#
920#	command_interpreter n	If not empty, command is interpreted, so
921#				call check_{pidfile,process}() appropriately.
922#
923#	desc		n	Description of script.
924#
925#	extra_commands	n	List of extra commands supported.
926#
927#	pidfile		n	If set, use check_pidfile $pidfile $command,
928#				otherwise use check_process $command.
929#				In either case, only check if $command is set.
930#
931#	procname	n	Process name to check for instead of $command.
932#
933#	rcvar		n	This is checked with checkyesno to determine
934#				if the action should be run.
935#
936#	${name}_program	n	Full path to command.
937#				Meant to be used in /etc/rc.conf to override
938#				${command}.
939#
940#	${name}_chroot	n	Directory to chroot to before running ${command}
941#				Requires /usr to be mounted.
942#
943#	${name}_chdir	n	Directory to cd to before running ${command}
944#				(if not using ${name}_chroot).
945#
946#	${name}_cpuset	n	A list of CPUs to run ${command} on.
947#				Requires /usr to be mounted.
948#
949#	${name}_flags	n	Arguments to call ${command} with.
950#				NOTE:	$flags from the parent environment
951#					can be used to override this.
952#
953#	${name}_env	n	Environment variables to run ${command} with.
954#
955#	${name}_env_file n	File to source variables to run ${command} with.
956#
957#	${name}_fib	n	Routing table number to run ${command} with.
958#
959#	${name}_nice	n	Nice level to run ${command} at.
960#
961#	${name}_oomprotect n	Don't kill ${command} when swap space is exhausted.
962#
963#	${name}_umask	n	The file creation mask to run ${command} with.
964#
965#	${name}_user	n	User to run ${command} as, using su(1) if not
966#				using ${name}_chroot.
967#				Requires /usr to be mounted.
968#
969#	${name}_group	n	Group to run chrooted ${command} as.
970#				Requires /usr to be mounted.
971#
972#	${name}_groups	n	Comma separated list of supplementary groups
973#				to run the chrooted ${command} with.
974#				Requires /usr to be mounted.
975#
976#	${name}_prepend	n	Command added before ${command}.
977#
978#	${name}_setup	n	Command executed during start, restart and
979#				reload before ${rc_arg}_precmd is run.
980#
981#	${name}_login_class n	Login class to use, else "daemon".
982#
983#	${name}_limits	n	limits(1) to apply to ${command}.
984#
985#	${name}_offcmd	n	If set, run during start
986#				if a service is not enabled.
987#
988#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
989#				Otherwise, use default command (see below)
990#
991#	${rc_arg}_precmd n	If set, run just before performing the
992#				${rc_arg}_cmd method in the default
993#				operation (i.e, after checking for required
994#				bits and process (non)existence).
995#				If this completes with a non-zero exit code,
996#				don't run ${rc_arg}_cmd.
997#
998#	${rc_arg}_postcmd n	If set, run just after performing the
999#				${rc_arg}_cmd method, if that method
1000#				returned a zero exit code.
1001#
1002#	required_dirs	n	If set, check for the existence of the given
1003#				directories before running a (re)start command.
1004#
1005#	required_files	n	If set, check for the readability of the given
1006#				files before running a (re)start command.
1007#
1008#	required_modules n	If set, ensure the given kernel modules are
1009#				loaded before running a (re)start command.
1010#				The check and possible loads are actually
1011#				done after start_precmd so that the modules
1012#				aren't loaded in vain, should the precmd
1013#				return a non-zero status to indicate a error.
1014#				If a word in the list looks like "foo:bar",
1015#				"foo" is the KLD file name and "bar" is the
1016#				module name.  If a word looks like "foo~bar",
1017#				"foo" is the KLD file name and "bar" is a
1018#				egrep(1) pattern matching the module name.
1019#				Otherwise the module name is assumed to be
1020#				the same as the KLD file name, which is most
1021#				common.  See load_kld().
1022#
1023#	required_vars	n	If set, perform checkyesno on each of the
1024#				listed variables before running the default
1025#				(re)start command.
1026#
1027#	Default behaviour for a given argument, if no override method is
1028#	provided:
1029#
1030#	Argument	Default behaviour
1031#	--------	-----------------
1032#	start		if !running && checkyesno ${rcvar}
1033#				${command}
1034#
1035#	stop		if ${pidfile}
1036#				rc_pid=$(check_pidfile $pidfile $command)
1037#			else
1038#				rc_pid=$(check_process $command)
1039#			kill $sig_stop $rc_pid
1040#			wait_for_pids $rc_pid
1041#			($sig_stop defaults to TERM.)
1042#
1043#	reload		Similar to stop, except use $sig_reload instead,
1044#			and don't wait_for_pids.
1045#			$sig_reload defaults to HUP.
1046#			Note that `reload' isn't provided by default,
1047#			it should be enabled via $extra_commands.
1048#
1049#	restart		Run `stop' then `start'.
1050#
1051#	status		Show if ${command} is running, etc.
1052#
1053#	poll		Wait for ${command} to exit.
1054#
1055#	rcvar		Display what rc.conf variable is used (if any).
1056#
1057#	enabled		Return true if the service is enabled.
1058#
1059#	describe	Show the service's description
1060#
1061#	extracommands	Show the service's extra commands
1062#
1063#	Variables available to methods, and after run_rc_command() has
1064#	completed:
1065#
1066#	Variable	Purpose
1067#	--------	-------
1068#	rc_arg		Argument to command, after fast/force/one processing
1069#			performed
1070#
1071#	rc_flags	Flags to start the default command with.
1072#			Defaults to ${name}_flags, unless overridden
1073#			by $flags from the environment.
1074#			This variable may be changed by the precmd method.
1075#
1076#	rc_service	Path to the service being executed, in case the service
1077#			needs to re-invoke itself.
1078#
1079#	rc_pid		PID of command (if appropriate)
1080#
1081#	rc_fast		Not empty if "fast" was provided (q.v.)
1082#
1083#	rc_force	Not empty if "force" was provided (q.v.)
1084#
1085#	rc_quiet	Not empty if "quiet" was provided
1086#
1087#
1088run_rc_command()
1089{
1090	_return=0
1091	rc_arg=$1
1092	if [ -z "$name" ]; then
1093		err 3 'run_rc_command: $name is not set.'
1094	fi
1095
1096	DebugOn rc:all rc:all:$rc_arg rc:$name rc:$name:$rc_arg $name:$rc_arg
1097
1098	# Don't repeat the first argument when passing additional command-
1099	# line arguments to the command subroutines.
1100	#
1101	shift 1
1102	rc_extra_args="$*"
1103
1104	_rc_prefix=
1105	case "$rc_arg" in
1106	fast*)				# "fast" prefix; don't check pid
1107		rc_arg=${rc_arg#fast}
1108		rc_fast=yes
1109		rc_quiet=yes
1110		;;
1111	force*)				# "force" prefix; always run
1112		rc_force=yes
1113		_rc_prefix=force
1114		rc_arg=${rc_arg#${_rc_prefix}}
1115		if [ -n "${rcvar}" ]; then
1116			eval ${rcvar}=YES
1117		fi
1118		;;
1119	one*)				# "one" prefix; set ${rcvar}=yes
1120		_rc_prefix=one
1121		rc_arg=${rc_arg#${_rc_prefix}}
1122		if [ -n "${rcvar}" ]; then
1123			eval ${rcvar}=YES
1124		fi
1125		;;
1126	quiet*)				# "quiet" prefix; omit some messages
1127		_rc_prefix=quiet
1128		rc_arg=${rc_arg#${_rc_prefix}}
1129		rc_quiet=yes
1130		;;
1131	esac
1132
1133	eval _override_command=\$${name}_program
1134	command=${_override_command:-$command}
1135
1136	_keywords="start stop restart rcvar enable disable delete enabled describe extracommands $extra_commands"
1137	rc_pid=
1138	_pidcmd=
1139	_procname=${procname:-${command}}
1140
1141	eval _cpuset=\$${name}_cpuset
1142
1143	# Loose validation of the configured cpuset; just make sure it starts
1144	# with a number.  There have also been cases in the past where a hyphen
1145	# in a service name has caused eval errors, which trickle down into
1146	# various variables; don't let a situation like that break a bunch of
1147	# services just because of cpuset(1).
1148	case "$_cpuset" in
1149	[0-9]*)	;;
1150	*)	_cpuset="" ;;
1151	esac
1152
1153	_cpusetcmd=
1154	if [ -n "$_cpuset" ]; then
1155		_cpusetcmd="$CPUSET -l $_cpuset"
1156	fi
1157
1158	# If a specific jail has a specific svcj request, honor it (YES/NO).
1159	# If not (variable empty), evaluate the global svcj catch-all.
1160	# A global YES can be overriden by a specific NO, and a global NO is overriden
1161	# by a specific YES.
1162	eval _svcj=\$${name}_svcj
1163	if [ -z "$_svcj" ]; then
1164		_svcj=${svcj_all_enable}
1165		if [ -z "$_svcj" ]; then
1166			eval ${name}_svcj=NO
1167		fi
1168	fi
1169
1170					# setup pid check command
1171	if [ -n "$_procname" ]; then
1172		if [ -n "$pidfile" ]; then
1173			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
1174		else
1175			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
1176		fi
1177		_keywords="${_keywords} status poll"
1178	else
1179		if [ ! -z "${status_cmd}" ]
1180		then
1181			_keywords="${_keywords} status"
1182		fi
1183	fi
1184
1185	if [ -z "$rc_arg" ]; then
1186		rc_usage $_keywords
1187	fi
1188
1189	if [ "$rc_arg" = "enabled" ] ; then
1190		checkyesno ${rcvar}
1191		return $?
1192	fi
1193
1194	if [ -n "$flags" ]; then	# allow override from environment
1195		rc_flags=$flags
1196	else
1197		eval rc_flags=\$${name}_flags
1198	fi
1199	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
1200	    _nice=\$${name}_nice	_user=\$${name}_user \
1201	    _group=\$${name}_group	_groups=\$${name}_groups \
1202	    _fib=\$${name}_fib		_env=\$${name}_env \
1203	    _prepend=\$${name}_prepend	_login_class=\${${name}_login_class:-daemon} \
1204	    _limits=\$${name}_limits	_oomprotect=\$${name}_oomprotect \
1205	    _setup=\$${name}_setup	_env_file=\$${name}_env_file \
1206	    _umask=\$${name}_umask	_svcj_options=\$${name}_svcj_options
1207
1208	if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then	# load env from file
1209		set -a
1210		. $_env_file
1211		set +a
1212	fi
1213
1214	if [ -n "$_user" ]; then	# unset $_user if running as that user
1215		if [ "$_user" = "$(eval $IDCMD)" ]; then
1216			unset _user
1217		fi
1218	fi
1219
1220	if [ -n "$_svcj_options" ]; then	# translate service jail options
1221		_svcj_cmd_options=""
1222
1223		_svcj_sysvipc_x=0
1224		for _svcj_option in $_svcj_options; do
1225			case "$_svcj_option" in
1226				mlock)
1227					_svcj_cmd_options="allow.mlock ${_svcj_cmd_options}"
1228					;;
1229				netv4)
1230					_svcj_cmd_options="ip4=inherit allow.reserved_ports ${_svcj_cmd_options}"
1231					;;
1232				netv6)
1233					_svcj_cmd_options="ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1234					;;
1235				net_basic)
1236					_svcj_cmd_options="ip4=inherit ip6=inherit allow.reserved_ports ${_svcj_cmd_options}"
1237					;;
1238				net_raw)
1239					_svcj_cmd_options="allow.raw_sockets ${_svcj_cmd_options}"
1240					;;
1241				net_all)
1242					_svcj_cmd_options="allow.socket_af allow.raw_sockets allow.reserved_ports ip4=inherit ip6=inherit ${_svcj_cmd_options}"
1243					;;
1244				nfsd)
1245					_svcj_cmd_options="allow.nfsd enforce_statfs=1 ${_svcj_cmd_options}"
1246					;;
1247				sysvipc)
1248					_svcj_sysvipc_x=$((${_svcj_sysvipc_x} + 1))
1249					_svcj_cmd_options="sysvmsg=inherit sysvsem=inherit sysvshm=inherit  ${_svcj_cmd_options}"
1250					;;
1251				sysvipcnew)
1252					_svcj_sysvipc_x=$((${_svcj_sysvipc_x} + 1))
1253					_svcj_cmd_options="sysvmsg=new sysvsem=new sysvshm=new ${_svcj_cmd_options}"
1254					;;
1255				vmm)
1256					_svcj_cmd_options="allow.vmm ${_svcj_cmd_options}"
1257					;;
1258				*)
1259					echo ${name}: unknown service jail option: $_svcj_option
1260					;;
1261			esac
1262		done
1263		if [ ${_svcj_sysvipc_x} -gt 1 ]; then
1264			echo -n "ERROR: more than one sysvipc option is "
1265			echo "specified in ${name}_svcj_options: $_svcj_options"
1266			return 1
1267		fi
1268	fi
1269
1270	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
1271
1272	for _elem in $_keywords; do
1273		if [ "$_elem" != "$rc_arg" ]; then
1274			continue
1275		fi
1276					# if ${rcvar} is set, $1 is not "rcvar", "describe",
1277					# "enable", "delete" or "status", and ${rc_pid} is
1278					# not set, run:
1279					#	checkyesno ${rcvar}
1280					# and return if that failed
1281					#
1282		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
1283		    -a "$rc_arg" != "delete" -a "$rc_arg" != "enable" \
1284		    -a "$rc_arg" != "describe" -a "$rc_arg" != "status" ] ||
1285		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
1286			if ! checkyesno ${rcvar}; then
1287			    [ "$rc_arg" = "start" ] && _run_rc_offcmd
1288			    if [ -z "${rc_quiet}" ]; then
1289				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
1290				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
1291				echo "instead of '${rc_arg}'."
1292			    fi
1293			    return 0
1294			fi
1295		fi
1296
1297		if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1298			if [ -z "$rc_quiet" ]; then
1299				echo 1>&2 "${name} already running? " \
1300				    "(pid=$rc_pid)."
1301			fi
1302			return 1
1303		fi
1304
1305		# if there's a custom ${XXX_cmd},
1306		# run that instead of the default
1307		#
1308		eval _cmd=\$${rc_arg}_cmd \
1309		     _precmd=\$${rc_arg}_precmd \
1310		     _postcmd=\$${rc_arg}_postcmd
1311
1312		if [ -n "$_cmd" ]; then
1313			rc_trace 1 "$_cmd"
1314			if [ -n "$_env" ]; then
1315				eval "export -- $_env"
1316			fi
1317
1318			if [ "${_rc_svcj}" != jailing ]; then
1319				# service can redefine all so
1320				# check for valid setup target
1321				if [ "$rc_arg" = 'start' -o \
1322				    "$rc_arg" = 'restart' -o \
1323				    "$rc_arg" = 'reload' ]; then
1324					_run_rc_setup || \
1325					    warn "failed to setup ${name}"
1326				fi
1327				_run_rc_precmd || return 1
1328			fi
1329			if ! checkyesno ${name}_svcj; then
1330				_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || return 1
1331			else
1332				case "$rc_arg" in
1333				start)
1334					if [ "${_rc_svcj}" != jailing ]; then
1335						_return=1
1336						_do_jailing=1
1337
1338						if check_jail jailed; then
1339							if [ $(${SYSCTL_N} security.jail.children.max) -eq 0 ]; then
1340								echo ERROR: jail parameter children.max is set to 0, can not create a new service jail.
1341								_do_jailing=0
1342							else
1343								_free_jails=$(($(${SYSCTL_N} security.jail.children.max) - $(${SYSCTL_N} security.jail.children.cur)))
1344								if [ ${_free_jails} -eq 0 ]; then
1345									echo ERROR: max number of jail children reached, can not create a new service jail.
1346									_do_jailing=0
1347
1348								fi
1349							fi
1350						fi
1351						if [ ${_do_jailing} -eq 1 ]; then
1352							$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options \
1353							    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1354							    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1355							    exec.consolelog="/var/log/svcj_${name}_console.log" \
1356							    name=svcj-${name} && _return=0
1357						fi
1358					else
1359						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1360					fi
1361					;;
1362				stop)
1363					if [ "${_rc_svcj}" != jailing ]; then
1364						$SERVICE -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}stop $rc_extra_args || _return=1
1365						$JAIL_CMD -r svcj-${name} 2>/dev/null
1366					else
1367						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1368					fi
1369					;;
1370				restart|status) ;; # no special case needed for svcj or handled somewhere else
1371				*)
1372					eval _rc_svcj_extra_cmd=\$${name}_${rc_arg}_svcj_enable
1373					: ${_rc_svcj_extra_cmd:=NO}
1374					if checkyesno _rc_svcj_extra_cmd && [ "${_rc_svcj}" != jailing ]; then
1375						$SERVICE -v -E _rc_svcj=jailing -j svcj-${name} ${name} ${_rc_prefix}${rc_arg} $rc_extra_args || _return=1
1376					else
1377						_run_rc_doit "$_cpusetcmd $_cmd $rc_extra_args" || _return=1
1378					fi
1379					;;
1380				esac
1381			fi
1382			if [ "${_rc_svcj}" != jailing ]; then
1383				_run_rc_postcmd
1384			fi
1385			return $_return
1386		fi
1387
1388		case "$rc_arg" in	# default operations...
1389
1390		describe)
1391			if [ -n "$desc" ]; then
1392				echo "$desc"
1393			fi
1394			;;
1395
1396		extracommands)
1397			echo "$extra_commands"
1398			;;
1399
1400		enable)
1401			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=YES") &&
1402				echo "$name enabled in ${_out%%:*}"
1403			;;
1404
1405		disable)
1406			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=NO") &&
1407				echo "$name disabled in ${_out%%:*}"
1408			;;
1409
1410		delete)
1411			_files=
1412			for _file in $(/usr/sbin/sysrc -lEs "$name"); do
1413				_out=$(/usr/sbin/sysrc -Fif $_file "$rcvar") && _files="$_files $_file"
1414			done
1415			/usr/sbin/sysrc -x "$rcvar" && echo "$rcvar deleted in ${_files# }"
1416				# delete file in rc.conf.d if desired and empty.
1417			checkyesno service_delete_empty || _files=
1418			for _file in $_files; do
1419				[ "$_file" = "${_file#*/rc.conf.d/}" ] && continue
1420				[ $(/usr/bin/stat -f%z $_file) -gt 0 ] && continue
1421				/bin/rm "$_file" && echo "Empty file $_file removed"
1422			done
1423			;;
1424
1425		status)
1426			_run_rc_precmd || return 1
1427			if [ -n "$rc_pid" ]; then
1428				echo "${name} is running as pid $rc_pid."
1429			else
1430				echo "${name} is not running."
1431				return 1
1432			fi
1433			_run_rc_postcmd
1434			;;
1435
1436		start)
1437			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1438				warn "run_rc_command: cannot run $command"
1439				return 1
1440			fi
1441
1442			if [ "${_rc_svcj}" != jailing ]; then
1443				_run_rc_setup || warn "failed to setup ${name}"
1444
1445				if ! _run_rc_precmd; then
1446					warn "failed precmd routine for ${name}"
1447					return 1
1448				fi
1449			fi
1450
1451			if checkyesno ${name}_svcj; then
1452				if [ "${_rc_svcj}" != jailing ]; then
1453					if check_jail jailed; then
1454						if [ $(${SYSCTL_N} security.jail.children.max) -eq 0 ]; then
1455							echo ERROR: jail parameter children.max is set to 0, can not create a new service jail.
1456							return 1
1457						else
1458							_free_jails=$(($(${SYSCTL_N} security.jail.children.max) - $(${SYSCTL_N} security.jail.children.cur)))
1459							if [ ${_free_jails} -eq 0 ]; then
1460								echo ERROR: max number of jail children reached, can not create a new service jail.
1461								return 1
1462							fi
1463						fi
1464					fi
1465					$JAIL_CMD -c $_svcj_generic_params $_svcj_cmd_options\
1466					    exec.start="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}start $rc_extra_args" \
1467					    exec.stop="${SERVICE} -E _rc_svcj=jailing ${name} ${_rc_prefix}stop $rc_extra_args" \
1468					    exec.consolelog="/var/log/svcj_${name}_console.log" \
1469					    name=svcj-${name} || return 1
1470				fi
1471			fi
1472
1473			# setup the full command to run
1474			#
1475			startmsg "Starting ${name}."
1476			if [ -n "$_chroot" ]; then
1477				_cd=
1478				_doit="\
1479${_nice:+nice -n $_nice }\
1480$_cpusetcmd \
1481${_fib:+setfib -F $_fib }\
1482${_env:+env $_env }\
1483chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1484$_chroot $command $rc_flags $command_args"
1485			else
1486				_cd="${_chdir:+cd $_chdir && }"
1487				_doit="\
1488${_fib:+setfib -F $_fib }\
1489${_env:+env $_env }\
1490$_cpusetcmd $command $rc_flags $command_args"
1491				if [ -n "$_user" ]; then
1492				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1493				fi
1494				if [ -n "$_nice" ]; then
1495					if [ -z "$_user" ]; then
1496						_doit="sh -c \"$_doit\""
1497					fi
1498					_doit="nice -n $_nice $_doit"
1499				fi
1500				if [ -n "$_prepend" ]; then
1501					_doit="$_prepend $_doit"
1502				fi
1503			fi
1504
1505			# Prepend default limits
1506			_doit="$_cd limits -C $_login_class $_limits $_doit"
1507
1508			local _really_run_it=true
1509			if checkyesno ${name}_svcj; then
1510				if [ "${_rc_svcj}" != jailing ]; then
1511					_really_run_it=false
1512				fi
1513			fi
1514
1515			if [ "$_really_run_it" = true ]; then
1516				# run the full command
1517				#
1518				if ! _run_rc_doit "$_doit"; then
1519					warn "failed to start ${name}"
1520					return 1
1521				fi
1522			fi
1523
1524			if [ "${_rc_svcj}" != jailing ]; then
1525				# finally, run postcmd
1526				#
1527				_run_rc_postcmd
1528			fi
1529			;;
1530
1531		stop)
1532			if [ -z "$rc_pid" ]; then
1533				[ -n "$rc_fast" ] && return 0
1534				_run_rc_notrunning
1535				return 1
1536			fi
1537
1538			_run_rc_precmd || return 1
1539
1540			# send the signal to stop
1541			#
1542			echo "Stopping ${name}."
1543			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1544			_run_rc_doit "$_doit" || return 1
1545
1546			# wait for the command to exit,
1547			# and run postcmd.
1548			wait_for_pids $rc_pid
1549
1550			if checkyesno ${name}_svcj; then
1551				# remove service jail
1552				$JAIL_CMD -r svcj-${name} 2>/dev/null
1553			fi
1554
1555			_run_rc_postcmd
1556			;;
1557
1558		reload)
1559			if [ -z "$rc_pid" ]; then
1560				_run_rc_notrunning
1561				return 1
1562			fi
1563
1564			_run_rc_setup || warn "failed to setup ${name}"
1565
1566			_run_rc_precmd || return 1
1567
1568			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1569			_run_rc_doit "$_doit" || return 1
1570
1571			_run_rc_postcmd
1572			;;
1573
1574		restart)
1575			_run_rc_setup || warn "failed to setup ${name}"
1576
1577			# prevent restart being called more
1578			# than once by any given script
1579			#
1580			if ${_rc_restart_done:-false}; then
1581				return 0
1582			fi
1583			_rc_restart_done=true
1584
1585			_run_rc_precmd || return 1
1586
1587			# run those in a subshell to keep global variables
1588			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1589			( run_rc_command ${_rc_prefix}start $rc_extra_args )
1590			_return=$?
1591			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1592
1593			_run_rc_postcmd
1594			;;
1595
1596		poll)
1597			_run_rc_precmd || return 1
1598			if [ -n "$rc_pid" ]; then
1599				wait_for_pids $rc_pid
1600			fi
1601			_run_rc_postcmd
1602			;;
1603
1604		rcvar)
1605			echo -n "# $name"
1606			if [ -n "$desc" ]; then
1607				echo " : $desc"
1608			else
1609				echo ""
1610			fi
1611			echo "#"
1612			# Get unique vars in $rcvar $rcvars
1613			for _v in $rcvar $rcvars; do
1614				case $v in
1615				$_v\ *|\ *$_v|*\ $_v\ *) ;;
1616				*)	v="${v# } $_v" ;;
1617				esac
1618			done
1619
1620			# Display variables.
1621			for _v in $v; do
1622				if [ -z "$_v" ]; then
1623					continue
1624				fi
1625
1626				eval _desc=\$${_v}_desc
1627				eval _defval=\$${_v}_defval
1628				_h="-"
1629
1630				eval echo \"$_v=\\\"\$$_v\\\"\"
1631				# decode multiple lines of _desc
1632				while [ -n "$_desc" ]; do
1633					case $_desc in
1634					*^^*)
1635						echo "# $_h ${_desc%%^^*}"
1636						_desc=${_desc#*^^}
1637						_h=" "
1638						;;
1639					*)
1640						echo "# $_h ${_desc}"
1641						break
1642						;;
1643					esac
1644				done
1645				echo "#   (default: \"$_defval\")"
1646			done
1647			echo ""
1648			;;
1649
1650		*)
1651			rc_usage $_keywords
1652			;;
1653
1654		esac
1655
1656		# Apply protect(1) to the PID if ${name}_oomprotect is set.
1657		case "$rc_arg" in
1658		start)
1659			# We cannot use protect(1) inside jails.
1660			if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1661			    [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1662				[ -z "${rc_pid}" ] && eval $_pidcmd
1663				case $_oomprotect in
1664				[Aa][Ll][Ll])
1665					${PROTECT} -d -i -p ${rc_pid}
1666					;;
1667				[Yy][Ee][Ss])
1668					${PROTECT} -p ${rc_pid}
1669					;;
1670				esac
1671			fi
1672		;;
1673		esac
1674
1675		return $_return
1676	done
1677
1678	echo 1>&2 "$0: unknown directive '$rc_arg'."
1679	rc_usage $_keywords
1680	# not reached
1681}
1682
1683#
1684# Helper functions for run_rc_command: common code.
1685# They use such global variables besides the exported rc_* ones:
1686#
1687#	name	       R/W
1688#	------------------
1689#	_offcmd		R
1690#	_precmd		R
1691#	_postcmd	R
1692#	_return		W
1693#	_setup		R
1694#
1695_run_rc_offcmd()
1696{
1697	eval _offcmd=\$${name}_offcmd
1698	if [ -n "$_offcmd" ]; then
1699		if [ -n "$_env" ]; then
1700			eval "export -- $_env"
1701		fi
1702		debug "run_rc_command: ${name}_offcmd: $_offcmd $rc_extra_args"
1703		eval "$_offcmd $rc_extra_args"
1704		_return=$?
1705	fi
1706	return 0
1707}
1708
1709_run_rc_precmd()
1710{
1711	check_required_before "$rc_arg" || return 1
1712
1713	if [ -n "$_precmd" ]; then
1714		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1715		eval "$_precmd $rc_extra_args"
1716		_return=$?
1717
1718		# If precmd failed and force isn't set, request exit.
1719		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1720			return 1
1721		fi
1722	fi
1723
1724	check_required_after "$rc_arg" || return 1
1725
1726	return 0
1727}
1728
1729_run_rc_postcmd()
1730{
1731	if [ -n "$_postcmd" ]; then
1732		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1733		eval "$_postcmd $rc_extra_args"
1734		_return=$?
1735	fi
1736	return 0
1737}
1738
1739_run_rc_setup()
1740{
1741	# prevent multiple execution on restart => stop/start split
1742	if ! ${_rc_restart_done:-false} && [ -n "$_setup" ]; then
1743		debug "run_rc_command: ${rc_arg}_setup: $_setup"
1744		eval "$_setup"
1745		_return=$?
1746		if [ $_return -ne 0 ]; then
1747			return 1
1748		fi
1749	fi
1750	return 0
1751}
1752
1753_run_rc_doit()
1754{
1755	local _m
1756
1757	debug "run_rc_command: doit: $*"
1758	_m=$(umask)
1759	${_umask:+umask ${_umask}}
1760	eval "$@"
1761	_return=$?
1762	umask ${_m}
1763
1764	# If command failed and force isn't set, request exit.
1765	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1766		return 1
1767	fi
1768
1769	return 0
1770}
1771
1772_run_rc_notrunning()
1773{
1774	local _pidmsg
1775
1776	if [ -n "$pidfile" ]; then
1777		_pidmsg=" (check $pidfile)."
1778	else
1779		_pidmsg=
1780	fi
1781	echo 1>&2 "${name} not running?${_pidmsg}"
1782}
1783
1784_run_rc_killcmd()
1785{
1786	local _cmd
1787
1788	_cmd="kill -$1 $rc_pid"
1789	if [ -n "$_user" ]; then
1790		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1791	fi
1792	echo "$_cmd"
1793}
1794
1795#
1796# run_rc_script file arg
1797#	Start the script `file' with `arg', and correctly handle the
1798#	return value from the script.
1799#	If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1800#	an old-style startup file.
1801#	If `file' appears to be a backup or scratch file, ignore it.
1802#	Otherwise if it is executable run as a child process.
1803#
1804run_rc_script()
1805{
1806	_file=$1
1807	_arg=$2
1808	if [ -z "$_file" -o -z "$_arg" ]; then
1809		err 3 'USAGE: run_rc_script file arg'
1810	fi
1811
1812	unset	name command command_args command_interpreter \
1813		extra_commands pidfile procname \
1814		rcvar rcvars rcvars_obsolete required_dirs required_files \
1815		required_vars
1816	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1817
1818	rc_trace 0 "$_file $_arg"
1819	# don't use it if we don't trust it
1820	is_verified $_file || return
1821
1822	rc_service="$_file"
1823	case "$_file" in
1824	/etc/rc.d/*.sh)			# no longer allowed in the base
1825		warn "Ignoring old-style startup script $_file"
1826		;;
1827	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
1828		warn "Ignoring scratch file $_file"
1829		;;
1830	*)				# run in subshell
1831		if [ -x $_file ]; then
1832			DebugOn $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1833
1834			if [ -n "$rc_boottrace" ]; then
1835				boottrace_fn "$_file" "$_arg"
1836			else
1837				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1838				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
1839				  trap "echo Script $_file running >&2" 29
1840				  set $_arg; . $_file )
1841			fi
1842			DebugOff rc=$? $_file $_file:$_arg rc:${_file##*/} rc:${_file##*/}:$_arg ${_file##*/} ${_file##*/}:$_arg
1843		fi
1844		;;
1845	esac
1846}
1847
1848#
1849# run_rc_scripts [options] file [...]
1850#
1851# Call `run_rc_script' for each "file" unless already listed in
1852# $_rc_elem_done.
1853#
1854# Options:
1855#
1856#	--arg "arg"
1857#		Pass "arg" to `run_rc_script' default is $_boot.
1858#
1859#	--break "marker"
1860#		If any "file" matches "marker" stop processing.
1861#
1862_rc_elem_done=
1863run_rc_scripts()
1864{
1865	local _arg=${_boot}
1866	local _rc_elem
1867	local _rc_breaks=
1868
1869	while :; do
1870		case "$1" in
1871		--arg)
1872                        _arg="$2"
1873                        shift 2
1874                        ;;
1875		--break)
1876                        _rc_breaks="$_rc_breaks $2"
1877                        shift 2
1878                        ;;
1879		*)
1880                        break
1881                        ;;
1882		esac
1883	done
1884	for _rc_elem in "$@"; do
1885		: _rc_elem=$_rc_elem
1886		case " $_rc_elem_done " in
1887		*" $_rc_elem "*)
1888                        continue
1889                        ;;
1890		esac
1891		run_rc_script ${_rc_elem} ${_arg}
1892		_rc_elem_done="$_rc_elem_done $_rc_elem"
1893		case " $_rc_breaks " in
1894		*" ${_rc_elem##*/} "*)
1895                        break
1896                        ;;
1897		esac
1898	done
1899}
1900
1901boottrace_fn()
1902{
1903	local _file _arg
1904	_file=$1
1905	_arg=$2
1906
1907	_boot="${_boot}" rc_fast="${rc_fast}" autoboot="${autoboot}" \
1908	    $boottrace_cmd "$_file" "$_arg"
1909}
1910
1911#
1912# load_rc_config [service]
1913#	Source in the configuration file(s) for a given service.
1914#	If no service is specified, only the global configuration
1915#	file(s) will be loaded.
1916#
1917load_rc_config()
1918{
1919	local _name _rcvar_val _var _defval _v _msg _new _d _dot
1920	_name=$1
1921	_dot=${load_rc_config_reader:-dot}
1922
1923	case "$_dot" in
1924	dot|[sv]dot)
1925		;;
1926	*)	warn "Ignoring invalid load_rc_config_reader"
1927		_dot=dot
1928		;;
1929	esac
1930	case "$1" in
1931	-s|--safe)
1932                _dot=sdot
1933                _name=$2
1934                shift
1935                ;;
1936	-v|--verify)
1937                _dot=vdot
1938                _name=$2
1939                shift
1940                ;;
1941	esac
1942
1943	DebugOn rc:$_name $_name
1944
1945	if ${_rc_conf_loaded:-false}; then
1946		:
1947	else
1948		if [ -r /etc/defaults/rc.conf ]; then
1949			debug "Sourcing /etc/defaults/rc.conf"
1950			$_dot /etc/defaults/rc.conf
1951			source_rc_confs
1952		elif [ -r /etc/rc.conf ]; then
1953			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1954			$_dot /etc/rc.conf
1955		fi
1956		_rc_conf_loaded=true
1957	fi
1958
1959	# If a service name was specified, attempt to load
1960	# service-specific configuration
1961	if [ -n "$_name" ] ; then
1962		for _d in /etc ${local_startup}; do
1963			_d=${_d%/rc.d}
1964			if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1965				debug "Sourcing ${_d}/rc.conf.d/$_name"
1966				$_dot ${_d}/rc.conf.d/"$_name"
1967			elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1968				local _rc
1969				for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1970					if [ -f "$_rc" ] ; then
1971						debug "Sourcing $_rc"
1972						$_dot "$_rc"
1973					fi
1974				done
1975			fi
1976		done
1977	fi
1978
1979	# Set defaults if defined.
1980	for _var in $rcvar $rcvars; do
1981		eval _defval=\$${_var}_defval
1982		if [ -n "$_defval" ]; then
1983			eval : \${$_var:=\$${_var}_defval}
1984		fi
1985	done
1986
1987	# check obsolete rc.conf variables
1988	for _var in $rcvars_obsolete; do
1989		eval _v=\$$_var
1990		eval _msg=\$${_var}_obsolete_msg
1991		eval _new=\$${_var}_newvar
1992		case $_v in
1993		"")
1994			;;
1995		*)
1996			if [ -z "$_new" ]; then
1997				_msg="Ignored."
1998			else
1999				eval $_new=\"\$$_var\"
2000				if [ -z "$_msg" ]; then
2001					_msg="Use \$$_new instead."
2002				fi
2003			fi
2004			warn "\$$_var is obsolete.  $_msg"
2005			;;
2006		esac
2007	done
2008}
2009
2010#
2011# load_rc_config_var name var
2012#	Read the rc.conf(5) var for name and set in the
2013#	current shell, using load_rc_config in a subshell to prevent
2014#	unwanted side effects from other variable assignments.
2015#
2016load_rc_config_var()
2017{
2018	if [ $# -ne 2 ]; then
2019		err 3 'USAGE: load_rc_config_var name var'
2020	fi
2021	eval $(eval '(
2022		load_rc_config '$1' >/dev/null;
2023		if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
2024			echo '$2'=\'\''${'$2'}\'\'';
2025		fi
2026	)' )
2027}
2028
2029#
2030# rc_usage commands
2031#	Print a usage string for $0, with `commands' being a list of
2032#	valid commands.
2033#
2034rc_usage()
2035{
2036	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
2037
2038	_sep=
2039	for _elem; do
2040		echo -n 1>&2 "$_sep$_elem"
2041		_sep="|"
2042	done
2043	echo 1>&2 ")"
2044	exit 1
2045}
2046
2047#
2048# err exitval message
2049#	Display message to stderr and log to the syslog, and exit with exitval.
2050#
2051err()
2052{
2053	exitval=$1
2054	shift
2055
2056	if [ -x /usr/bin/logger ]; then
2057		logger "$0: ERROR: $*"
2058	fi
2059	echo 1>&2 "$0: ERROR: $*"
2060	exit $exitval
2061}
2062
2063#
2064# warn message
2065#	Display message to stderr and log to the syslog.
2066#
2067warn()
2068{
2069	if [ -x /usr/bin/logger ]; then
2070		logger "$0: WARNING: $*"
2071	fi
2072	echo 1>&2 "$0: WARNING: $*"
2073}
2074
2075#
2076# info message
2077#	Display informational message to stdout and log to syslog.
2078#
2079info()
2080{
2081	case ${rc_info} in
2082	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2083		if [ -x /usr/bin/logger ]; then
2084			logger "$0: INFO: $*"
2085		fi
2086		echo "$0: INFO: $*"
2087		;;
2088	esac
2089}
2090
2091#
2092# debug message
2093#	If debugging is enabled in rc.conf output message to stderr.
2094#	BEWARE that you don't call any subroutine that itself calls this
2095#	function.
2096#
2097debug()
2098{
2099	case ${rc_debug} in
2100	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
2101		if [ -x /usr/bin/logger ]; then
2102			logger "$0: DEBUG: $*"
2103		fi
2104		echo 1>&2 "$0: DEBUG: $*"
2105		;;
2106	esac
2107}
2108
2109#
2110# backup_file action file cur backup
2111#	Make a backup copy of `file' into `cur', and save the previous
2112#	version of `cur' as `backup'.
2113#
2114#	The `action' keyword can be one of the following:
2115#
2116#	add		`file' is now being backed up (and is possibly
2117#			being reentered into the backups system).  `cur'
2118#			is created.
2119#
2120#	update		`file' has changed and needs to be backed up.
2121#			If `cur' exists, it is copied to `back'
2122#			and then `file' is copied to `cur'.
2123#
2124#	remove		`file' is no longer being tracked by the backups
2125#			system.  `cur' is moved `back'.
2126#
2127#
2128backup_file()
2129{
2130	_action=$1
2131	_file=$2
2132	_cur=$3
2133	_back=$4
2134
2135	case $_action in
2136	add|update)
2137		if [ -f $_cur ]; then
2138			cp -p $_cur $_back
2139		fi
2140		cp -p $_file $_cur
2141		chown root:wheel $_cur
2142		;;
2143	remove)
2144		mv -f $_cur $_back
2145		;;
2146	esac
2147}
2148
2149# make_symlink src link
2150#	Make a symbolic link 'link' to src from basedir. If the
2151#	directory in which link is to be created does not exist
2152#	a warning will be displayed and an error will be returned.
2153#	Returns 0 on success, 1 otherwise.
2154#
2155make_symlink()
2156{
2157	local src link linkdir _me
2158	src="$1"
2159	link="$2"
2160	linkdir="`dirname $link`"
2161	_me="make_symlink()"
2162
2163	if [ -z "$src" -o -z "$link" ]; then
2164		warn "$_me: requires two arguments."
2165		return 1
2166	fi
2167	if [ ! -d "$linkdir" ]; then
2168		warn "$_me: the directory $linkdir does not exist."
2169		return 1
2170	fi
2171	if ! ln -sf $src $link; then
2172		warn "$_me: unable to make a symbolic link from $link to $src"
2173		return 1
2174	fi
2175	return 0
2176}
2177
2178# devfs_rulesets_from_file file
2179#	Reads a set of devfs commands from file, and creates
2180#	the specified rulesets with their rules. Returns non-zero
2181#	if there was an error.
2182#
2183devfs_rulesets_from_file()
2184{
2185	local file _err _me _opts
2186	file="$1"
2187	_me="devfs_rulesets_from_file"
2188	_err=0
2189
2190	if [ -z "$file" ]; then
2191		warn "$_me: you must specify a file"
2192		return 1
2193	fi
2194	if [ ! -e "$file" ]; then
2195		debug "$_me: no such file ($file)"
2196		return 0
2197	fi
2198
2199	# Disable globbing so that the rule patterns are not expanded
2200	# by accident with matching filesystem entries.
2201	_opts=$-; set -f
2202
2203	debug "reading rulesets from file ($file)"
2204	{ while read line
2205	do
2206		case $line in
2207		\#*)
2208			continue
2209			;;
2210		\[*\]*)
2211			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
2212			if [ -z "$rulenum" ]; then
2213				warn "$_me: cannot extract rule number ($line)"
2214				_err=1
2215				break
2216			fi
2217			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
2218			if [ -z "$rulename" ]; then
2219				warn "$_me: cannot extract rule name ($line)"
2220				_err=1
2221				break;
2222			fi
2223			eval $rulename=\$rulenum
2224			debug "found ruleset: $rulename=$rulenum"
2225			if ! /sbin/devfs rule -s $rulenum delset; then
2226				_err=1
2227				break
2228			fi
2229			;;
2230		*)
2231			rulecmd="${line%%"\#*"}"
2232			# evaluate the command incase it includes
2233			# other rules
2234			if [ -n "$rulecmd" ]; then
2235				debug "adding rule ($rulecmd)"
2236				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
2237				then
2238					_err=1
2239					break
2240				fi
2241			fi
2242			;;
2243		esac
2244		if [ $_err -ne 0 ]; then
2245			debug "error in $_me"
2246			break
2247		fi
2248	done } < $file
2249	case $_opts in *f*) ;; *) set +f ;; esac
2250	return $_err
2251}
2252
2253# devfs_init_rulesets
2254#	Initializes rulesets from configuration files. Returns
2255#	non-zero if there was an error.
2256#
2257devfs_init_rulesets()
2258{
2259	local file _me
2260	_me="devfs_init_rulesets"
2261
2262	# Go through this only once
2263	if [ -n "$devfs_rulesets_init" ]; then
2264		debug "$_me: devfs rulesets already initialized"
2265		return
2266	fi
2267	for file in $devfs_rulesets; do
2268		if ! devfs_rulesets_from_file $file; then
2269			warn "$_me: could not read rules from $file"
2270			return 1
2271		fi
2272	done
2273	devfs_rulesets_init=1
2274	debug "$_me: devfs rulesets initialized"
2275	return 0
2276}
2277
2278# devfs_set_ruleset ruleset [dir]
2279#	Sets the default ruleset of dir to ruleset. The ruleset argument
2280#	must be a ruleset name as specified in devfs.rules(5) file.
2281#	Returns non-zero if it could not set it successfully.
2282#
2283devfs_set_ruleset()
2284{
2285	local devdir rs _me
2286	[ -n "$1" ] && eval rs=\$$1 || rs=
2287	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2288	_me="devfs_set_ruleset"
2289
2290	if [ -z "$rs" ]; then
2291		warn "$_me: you must specify a ruleset number"
2292		return 1
2293	fi
2294	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
2295	if ! /sbin/devfs $devdir ruleset $rs; then
2296		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
2297		return 1
2298	fi
2299	return 0
2300}
2301
2302# devfs_apply_ruleset ruleset [dir]
2303#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
2304#	The ruleset argument must be a ruleset name as specified
2305#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
2306#	if it could not apply the ruleset.
2307#
2308devfs_apply_ruleset()
2309{
2310	local devdir rs _me
2311	[ -n "$1" ] && eval rs=\$$1 || rs=
2312	[ -n "$2" ] && devdir="-m "$2"" || devdir=
2313	_me="devfs_apply_ruleset"
2314
2315	if [ -z "$rs" ]; then
2316		warn "$_me: you must specify a ruleset"
2317		return 1
2318	fi
2319	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
2320	if ! /sbin/devfs $devdir rule -s $rs applyset; then
2321		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
2322		return 1
2323	fi
2324	return 0
2325}
2326
2327# devfs_domount dir [ruleset]
2328#	Mount devfs on dir. If ruleset is specified it is set
2329#	on the mount-point. It must also be a ruleset name as specified
2330#	in a devfs.rules(5) file. Returns 0 on success.
2331#
2332devfs_domount()
2333{
2334	local devdir rs _me
2335	devdir="$1"
2336	[ -n "$2" ] && rs=$2 || rs=
2337	_me="devfs_domount()"
2338
2339	if [ -z "$devdir" ]; then
2340		warn "$_me: you must specify a mount-point"
2341		return 1
2342	fi
2343	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
2344	if ! mount -t devfs dev "$devdir"; then
2345		warn "$_me: Unable to mount devfs on $devdir"
2346		return 1
2347	fi
2348	if [ -n "$rs" ]; then
2349		devfs_init_rulesets
2350		devfs_set_ruleset $rs $devdir
2351		devfs -m $devdir rule applyset
2352	fi
2353	return 0
2354}
2355
2356# Provide a function for normalizing the mounting of memory
2357# filesystems.  This should allow the rest of the code here to remain
2358# as close as possible between 5-current and 4-stable.
2359#   $1 = size
2360#   $2 = mount point
2361#   $3 = (optional) extra mdmfs flags
2362mount_md()
2363{
2364	if [ -n "$3" ]; then
2365		flags="$3"
2366	fi
2367	/sbin/mdmfs $flags -s $1 ${mfs_type} $2
2368}
2369
2370# Code common to scripts that need to load a kernel module
2371# if it isn't in the kernel yet. Syntax:
2372#   load_kld [-e regex] [-m module] file
2373# where -e or -m chooses the way to check if the module
2374# is already loaded:
2375#   regex is egrep'd in the output from `kldstat -v',
2376#   module is passed to `kldstat -m'.
2377# The default way is as though `-m file' were specified.
2378load_kld()
2379{
2380	local _loaded _mod _opt _re
2381
2382	while getopts "e:m:" _opt; do
2383		case "$_opt" in
2384		e) _re="$OPTARG" ;;
2385		m) _mod="$OPTARG" ;;
2386		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
2387		esac
2388	done
2389	shift $(($OPTIND - 1))
2390	if [ $# -ne 1 ]; then
2391		err 3 'USAGE: load_kld [-e regex] [-m module] file'
2392	fi
2393	_mod=${_mod:-$1}
2394	_loaded=false
2395	if [ -n "$_re" ]; then
2396		if kldstat -v | egrep -q -e "$_re"; then
2397			_loaded=true
2398		fi
2399	else
2400		if kldstat -q -m "$_mod"; then
2401			_loaded=true
2402		fi
2403	fi
2404	if ! $_loaded; then
2405		if ! kldload "$1"; then
2406			warn "Unable to load kernel module $1"
2407			return 1
2408		else
2409			info "$1 kernel module loaded."
2410			if [ -f "/etc/sysctl.kld.d/$1.conf" ]; then
2411				sysctl -f "/etc/sysctl.kld.d/$1.conf"
2412			fi
2413		fi
2414	else
2415		debug "load_kld: $1 kernel module already loaded."
2416	fi
2417	return 0
2418}
2419
2420# ltr str src dst [var]
2421#	Change every $src in $str to $dst.
2422#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
2423#	awk(1). If var is non-NULL, set it to the result.
2424ltr()
2425{
2426	local _str _src _dst _out _com _var
2427	_str="$1"
2428	_src="$2"
2429	_dst="$3"
2430	_var="$4"
2431	_out=""
2432
2433	local IFS="${_src}"
2434	for _com in ${_str}; do
2435		if [ -z "${_out}" ]; then
2436			_out="${_com}"
2437		else
2438			_out="${_out}${_dst}${_com}"
2439		fi
2440	done
2441	if [ -n "${_var}" ]; then
2442		setvar "${_var}" "${_out}"
2443	else
2444		echo "${_out}"
2445	fi
2446}
2447
2448# Creates a list of providers for GELI encryption.
2449geli_make_list()
2450{
2451	local devices devices2
2452	local provider mountpoint type options rest
2453
2454	# Create list of GELI providers from fstab.
2455	while read provider mountpoint type options rest ; do
2456		case ":${options}" in
2457		:*noauto*)
2458			noauto=yes
2459			;;
2460		*)
2461			noauto=no
2462			;;
2463		esac
2464
2465		case ":${provider}" in
2466		:#*)
2467			continue
2468			;;
2469		*.eli)
2470			# Skip swap devices.
2471			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
2472				continue
2473			fi
2474			devices="${devices} ${provider}"
2475			;;
2476		esac
2477	done < /etc/fstab
2478
2479	# Append providers from geli_devices.
2480	devices="${devices} ${geli_devices}"
2481
2482	for provider in ${devices}; do
2483		provider=${provider%.eli}
2484		provider=${provider#/dev/}
2485		devices2="${devices2} ${provider}"
2486	done
2487
2488	echo ${devices2}
2489}
2490
2491# Originally, root mount hold had to be released before mounting
2492# the root filesystem.  This delayed the boot, so it was changed
2493# to only wait if the root device isn't readily available.  This
2494# can result in rc scripts executing before all the devices - such
2495# as graid(8), or USB disks - can be accessed.  This function can
2496# be used to explicitly wait for root mount holds to be released.
2497root_hold_wait()
2498{
2499	local wait waited holders
2500
2501	waited=0
2502	while true; do
2503		holders="$(sysctl -n vfs.root_mount_hold)"
2504		if [ -z "${holders}" ]; then
2505			break;
2506		fi
2507		if [ ${waited} -eq 0 ]; then
2508			echo -n "Waiting ${root_hold_delay}s" \
2509			"for the root mount holders: ${holders}"
2510		else
2511			echo -n .
2512		fi
2513		if [ ${waited} -ge ${root_hold_delay} ]; then
2514			echo
2515			break
2516		fi
2517		sleep 1
2518		waited=$(($waited + 1))
2519	done
2520}
2521
2522# Find scripts in local_startup directories that use the old syntax
2523#
2524find_local_scripts_old() {
2525	zlist=''
2526	slist=''
2527	for dir in ${local_startup}; do
2528		if [ -d "${dir}" ]; then
2529			for file in ${dir}/[0-9]*.sh; do
2530				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2531				    continue
2532				zlist="$zlist $file"
2533			done
2534			for file in ${dir}/[!0-9]*.sh; do
2535				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2536				    continue
2537				slist="$slist $file"
2538			done
2539		fi
2540	done
2541}
2542
2543find_local_scripts_new() {
2544	local_rc=''
2545	for dir in ${local_startup}; do
2546		if [ -d "${dir}" ]; then
2547			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
2548				case "$file" in
2549				*.sample|*.pkgsave) ;;
2550				*)	if [ -x "$file" ]; then
2551						local_rc="${local_rc} ${file}"
2552					fi
2553					;;
2554				esac
2555			done
2556		fi
2557	done
2558}
2559
2560find_system_scripts() {
2561	system_rc=''
2562	for file in /etc/rc.d/*; do
2563		case "${file##*/}" in
2564		*.pkgsave) ;;
2565		*)	if [ -x "$file" ]; then
2566				system_rc="${system_rc} ${file}"
2567			fi
2568			;;
2569		esac
2570	done
2571}
2572
2573# check_required_{before|after} command
2574#	Check for things required by the command before and after its precmd,
2575#	respectively.  The two separate functions are needed because some
2576#	conditions should prevent precmd from being run while other things
2577#	depend on precmd having already been run.
2578#
2579check_required_before()
2580{
2581	local _f
2582
2583	case "$1" in
2584	start)
2585		for _f in $required_vars; do
2586			if ! checkyesno $_f; then
2587				warn "\$${_f} is not enabled."
2588				if [ -z "$rc_force" ]; then
2589					return 1
2590				fi
2591			fi
2592		done
2593
2594		for _f in $required_dirs; do
2595			if [ ! -d "${_f}/." ]; then
2596				warn "${_f} is not a directory."
2597				if [ -z "$rc_force" ]; then
2598					return 1
2599				fi
2600			fi
2601		done
2602
2603		for _f in $required_files; do
2604			if [ ! -r "${_f}" ]; then
2605				warn "${_f} is not readable."
2606				if [ -z "$rc_force" ]; then
2607					return 1
2608				fi
2609			fi
2610		done
2611		;;
2612	esac
2613
2614	return 0
2615}
2616
2617check_required_after()
2618{
2619	local _f _args
2620
2621	case "$1" in
2622	start)
2623		for _f in $required_modules; do
2624			case "${_f}" in
2625				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
2626				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
2627				*)	_args="${_f}" ;;
2628			esac
2629			if ! load_kld ${_args}; then
2630				if [ -z "$rc_force" ]; then
2631					return 1
2632				fi
2633			fi
2634		done
2635		;;
2636	esac
2637
2638	return 0
2639}
2640
2641# check_jail mib
2642#	Return true if security.jail.$mib exists and set to 1.
2643
2644check_jail()
2645{
2646	local _mib _v
2647
2648	_mib=$1
2649	if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2650		case $_v in
2651		1)	return 0;;
2652		esac
2653	fi
2654	return 1
2655}
2656
2657# check_kern_features mib
2658#	Return existence of kern.features.* sysctl MIB as true or
2659#	false.  The result will be cached in $_rc_cache_kern_features_
2660#	namespace.  "0" means the kern.features.X exists.
2661
2662check_kern_features()
2663{
2664	local _v
2665
2666	[ -n "$1" ] || return 1;
2667	eval _v=\$_rc_cache_kern_features_$1
2668	[ -n "$_v" ] && return "$_v";
2669
2670	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2671		eval _rc_cache_kern_features_$1=0
2672		return 0
2673	else
2674		eval _rc_cache_kern_features_$1=1
2675		return 1
2676	fi
2677}
2678
2679# check_namevarlist var
2680#	Return "0" if ${name}_var is reserved in rc.subr.
2681
2682_rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend setup"
2683check_namevarlist()
2684{
2685	local _v
2686
2687	for _v in $_rc_namevarlist; do
2688	case $1 in
2689	$_v)	return 0 ;;
2690	esac
2691	done
2692
2693	return 1
2694}
2695
2696# _echoonce var msg mode
2697#	mode=0: Echo $msg if ${$var} is empty.
2698#	        After doing echo, a string is set to ${$var}.
2699#
2700#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
2701#
2702_echoonce()
2703{
2704	local _var _msg _mode
2705	eval _var=\$$1
2706	_msg=$2
2707	_mode=$3
2708
2709	case $_mode in
2710	1)	[ -n "$_var" ] && echo "$_msg" ;;
2711	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2712	esac
2713}
2714
2715# If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2716# still override this, but /etc/defaults/rc.conf can't unconditionally set this
2717# since it would undo what we've done here.
2718if kenv -q rc.debug > /dev/null ; then
2719	rc_debug=YES
2720fi
2721
2722boottrace_cmd=`command -v boottrace`
2723if [ -n "$boottrace_cmd" ] && [ "`${SYSCTL_N} -q kern.boottrace.enabled`" = "1" ]; then
2724	rc_boottrace=YES
2725fi
2726
2727SED=${SED:-$(Exists -x /usr/bin/sed /rescue/sed)}
2728
2729# Allow for local additions and overrides.
2730# Use vdot to ensure the file has not been tampered with.
2731vdot /etc/local.rc.subr
2732
2733# Avoid noise - when we do not have /usr mounted,
2734# and we cannot use safe_dot without sed.
2735if ! have basename; then
2736	basename()
2737	{
2738		local b=${1%$2}
2739		echo ${b##*/}
2740	}
2741	tty()
2742	{
2743		return 0
2744	}
2745	# we cannot use safe_dot without sed
2746	[ -z "$SED" ] && _SAFE_EVAL_SH=:
2747fi
2748# safe_eval.sh provides safe_dot - for untrusted files
2749$_SAFE_EVAL_SH vdot /libexec/safe_eval.sh
2750$_DEBUG_SH vdot /libexec/debug.sh
2751
2752# Ensure we can still operate if debug.sh and
2753# safe_eval.sh are not found.
2754if ! have DebugOn; then
2755	DebugOn() { return 0; }
2756	DebugOff() {
2757		local _rc=0
2758		while :
2759		do
2760			case "$1" in
2761			-[eo]) shift;; # ignore it
2762			rc=*) eval "_$1"; shift;;
2763			*) break;;
2764			esac
2765		done
2766		return $_rc
2767	}
2768fi
2769if ! have safe_dot; then
2770	safe_dot() { dot "$@"; }
2771fi
2772